;; Perform math on text numbers in-place, by Carl Bassler, coded March 2000
;; 10/16/07 Update to allow use in various units, suggestion by M. Roeder
;;  10/17/07 Add option to add numbers, place the sum as text 
;;-------------------------------------------
(princ "Do math on text  Start with \"TXM\"")
;;------------------------------------------ 
(defun c:txm()
   (terpri)
   (setvar "cmdecho" 0)
   (command "._Undo" "_BE")
   (setq U_Units (getvar "lunits"))
   ;;----Option to (A)dd strings or (G)lobal math------------
   (initget  "A G")
   (setq input (getkword "\nAdd<A> numbers or Global<G> edits: "))
   (cond
      ((= input "A") (AddNumbers))
      ((= input "G") (GlobalMath))
      (T nil)
   ) ; cond
   
   (command "._UNDO" "_E")
   (setvar "cmdecho" 1)
   (princ)
) ; the end
;;==============================================================
(defun GlobalMath ()
   ;;-----------------------
   (setq mfactor 1 afactor 0 input nil)
   (initget  "M A")
   (setq input (getkword "\nMultiply<M> or Add<A>?: "))
   (cond
      ((= input "M") (initget 1) 
                     (setq mfactor$ (getstring T "\nMult Factor: ")
                           mfactor (distof mfactor$ U_Units))
       )
      ((= input "A") (initget 1)
                     (setq afactor$ (getstring T "\nAdd Amount: ")
                            afactor (distof afactor$ U_Units))
       )
      (T nil)
   ) ; cond
   (setq Precis 4);;default precision
   ;;reove comments following 2 lines for general use
   ;;  (initget 1)
   ;;  (setq precis (getint "\nPlaces after decimal: "))
   (setq Units "")
   ;;remove comments following lines for general use
   ;; (setq units (getstring T "\nEnter units to append: "))
   ;;--------
   (princ "\nSelect text to revise: ")
   (setq textset nil)
   (while (not textset) (setq textset (ssget '((0 . "*TEXT")))))
   (setq numitems (sslength textset))
   ;; loop to isolate text & change text
   (setq itemno 0)
   (repeat numitems 
     (setq entname (ssname textset itemno))
     ;;(setq enttype (cdr (assoc 0 (entget entname))))
     (setq oldtxt_pr (assoc 1 (entget entname)))
     (setq oldtxt (cdr oldtxt_pr))
     ;;(setq oldtext# (atof oldtxt))
     (setq oldtext# (distof oldtxt U_Units))
     (setq newtext# (+ (* oldtext# mfactor) afactor))
     (setq newtxt (strcat (rtos newtext# U_Units precis) units))
     (setq newtxt_pr (cons 1 newtxt))
     (setq entstuff (entget entname))
     (setq entstuff (subst newtxt_pr oldtxt_pr entstuff))
     (entmod entstuff)
     (setq itemno (1+ itemno))
   ) ;  repeat
   (princ)
)
;;--------------------------------------------
(defun AddNumbers ()
   (setq Precis 4);;default precision
   (princ "\nSelect text to sum: ")
   (setq SumSet (ssget '((0 . "*TEXT"))))
   (setq Count 0 TotSum 0)
   (setq NumItems (sslength SumSet))
   (repeat NumItems
      (setq Ename (ssname SumSet Count))
      (setq Num$ (cdr (assoc 1 (entget Ename))))
      (setq Num (distof Num$ U_Units))
      (if Num
          (setq TotSum (+ Num TotSum) Elast Ename)
          (princ (strcat "\n** " Num$ " rejected from total **"))
      )
      (setq Count (1+ Count))
   )
   (setq TotSum$ (rtos TotSum U_Units Precis)) 
   ;;---------place text------------
   (command "._copy" Elast "" "0,0" "")
   (setq TxtNew (entlast)
         TxtData (entget TxtNew)
         TxtIns (trans (cdr (assoc 10 TxtData)) 0 1);;UCS INS
         SumData (subst (cons 1 TotSum$) (assoc 1 TxtData) TxtData)
   )
   (entmod SumData)
   (princ "\nSelect location for total sum: ")
   (command "._move" (entlast) "" TxtIns pause)  
)
;;-----------------------------
    
      
   
   

